{-
	Copyright (C) 2021 Dr. Alistair Ward

	This file is part of BishBosh.

	BishBosh is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	BishBosh is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BishBosh.  If not, see <http://www.gnu.org/licenses/>.
-}
{- |
 [@AUTHOR@]	Dr. Alistair Ward

 [@DESCRIPTION@]	Static tests.
-}

module BishBosh.Test.HUnit.Text.AutoComplete(
-- * Constants
	testCases
) where

import qualified	BishBosh.Text.AutoComplete	as Text.AutoComplete
import qualified	Test.HUnit
import			Test.HUnit((~?))

-- | Check the sanity of the implementation, by validating a list of static test-cases.
testCases :: Test.HUnit.Test
testCases	= Test.HUnit.test [
	let
		sample	= take 3 ['a' ..]
		suffix	= " dEf"
	in Text.AutoComplete.autoComplete [
		[a, b, c, 'd'] |
			a	<- sample,
			b	<- sample,
			c	<- sample
	] ("AbC" ++ suffix) == (take 4 ['a' ..] ++ suffix) ~? "BishBosh.Text.AutoComplete.autoComplete:\tfailed."
 ]

